diff -urpNX dontdiff linux-2.5.40/fs/fcntl.c linux-2.5.40-willy/fs/fcntl.c
--- linux-2.5.40/fs/fcntl.c	2002-10-01 03:06:17.000000000 -0400
+++ linux-2.5.40-willy/fs/fcntl.c	2002-10-03 15:48:19.000000000 -0400
@@ -491,15 +491,17 @@ void send_sigio(struct fown_struct *fown
 		goto out_unlock_fown;
 	
 	read_lock(&tasklist_lock);
-	if ( (pid > 0) && (p = find_task_by_pid(pid)) ) {
-		send_sigio_to_task(p, fown, fd, band);
-		goto out_unlock_task;
-	}
-	for_each_task_pid(-pid, PIDTYPE_PGID, p, l, pidptr)
-		send_sigio_to_task(p, fown,fd,band);
-out_unlock_task:
+	if (pid > 0) {
+		if (p = find_task_by_pid(pid)) {
+			send_sigio_to_task(p, fown, fd, band);
+		}
+	} else {
+		for_each_task_pid(-pid, PIDTYPE_PGID, p, l, pidptr) {
+			send_sigio_to_task(p, fown, fd, band);
+		}
+	}
 	read_unlock(&tasklist_lock);
-out_unlock_fown:
+ out_unlock_fown:
 	read_unlock(&fown->lock);
 }
 
@@ -523,21 +525,17 @@ int send_sigurg(struct fown_struct *fown
 	ret = 1;
 	
 	read_lock(&tasklist_lock);
-	if ((pid > 0) && (p = find_task_by_pid(pid))) {
-		send_sigurg_to_task(p, fown);
-		goto out_unlock_task;
-	}
-	for_each_process(p) {
-		int match = p->pid;
-		if (pid < 0)
-			match = -p->pgrp;
-		if (pid != match)
-			continue;
-		send_sigurg_to_task(p, fown);
+	if (pid > 0) {
+		if (p = find_task_by_pid(pid)) {
+			send_sigurg_to_task(p, fown);
+		}
+	} else {
+		for_each_task_pid(-pid, PIDTYPE_PGID, p, l, pidptr) {
+			send_sigurg_to_task(p, fown);
+		}
 	}
-out_unlock_task:
 	read_unlock(&tasklist_lock);
-out_unlock_fown:
+ out_unlock_fown:
 	read_unlock(&fown->lock);
 	return ret;
 }
